const app = getApp();
Page({
  data: {
    userInfo: {},
    shorter_nickname:null,
    hasUserInfo: false,
    multiArray_top:[['全部','蔬菜','豆/豆制品','肉禽蛋','水产海鲜','水果','乳品烘焙','粮油米面','调味品','酒水饮料','熟食卤味','速食冻品'],['新鲜优先','不新鲜优先']],
    multiIndex_top:[0,0],
    selected_kind:"全部",
    fresh:"新鲜优先",
    stock:null,
    if_reverse:"column-reverse",
    day_limit:3,
    exists_outdated:false,
  },

  login(){
    wx.login({
      success: (res)=> {
        if (res.code) {
          this.setData({  
            code:res.code
          })
        } else {
          console.log('登录失败！' + res.errMsg)
        }
      }
    })
    wx.showModal({
      title: '一餐一食',
      content: '请登录',
      showCancel : false,
      confirmText:"登录",
      success: (res) =>{
          wx.getUserProfile({
            desc: '展示用户信息', // 声明获取用户个人信息后的用途，后续会展示在弹窗中，请谨慎填写
            success: (res) => {
              app.globalData.userInfo = res.userInfo
              this.setData( {
                userInfo:res.userInfo,
                hasUserInfo:true,
                shorter_nickname:res.userInfo.nickName.substring(0,10),
              } );
              console.log(res.userInfo)
              
              wx.cloud.callContainer({
                "config": {
                  "env": "prod-2g058voqbea31ecb"
                },
                "path": "/general/nickname/",
                "header": {
                  "X-WX-SERVICE": "django-5198",
                  'content-type': 'application/x-www-form-urlencoded'
                },
                "method": "POST",
                data: res.userInfo,
                success(res){
                  console.log(res)
                }
              })
            },
            fail:(res)=>{
              this.login()
            }
          })
         }
    })
    
  },
  
  get_food_stock(){
    var that = this
    wx.cloud.callContainer({
      "config": {
        "env": "prod-2g058voqbea31ecb"
      },
      "path": "fridge/food-stock/",
      "header": {
        "X-WX-SERVICE": "django-5198",
        'content-type': 'application/x-www-form-urlencoded;charset=utf-8'
      },
      "method": "GET",
      data:{day_limit:this.data.day_limit},
      success(res){
        let check = "\"outdated\": 1"
        if(res.data.result.indexOf(check)>=0){
          that.setData({
            exists_outdated:true
          })
        }
        let arr = app.parse_json(res)
        that.setData({
          stock:arr,
        })
      }
    })
  },

  onLoad(){
    this.login()
  },
  onShow(){
    this.get_food_stock()
  },
  bindMultiPickerChange_top: function (e) {
    console.log('picker发送选择改变，携带值为', e.detail.value)
    this.setData({
      selected_kind:this.data.multiArray_top[0][e.detail.value[0]],
      fresh:this.data.multiArray_top[1][e.detail.value[1]]
    })
    if(e.detail.value[1]==1){
      this.setData({
        if_reverse:"column"
      })
    }
    else{
      this.setData({
        if_reverse:"column-reverse"
      })
    }

  },

  bindMultiPickerColumnChange_top: function (e) {
    console.log('修改的列为', e.detail.column, '，值为', e.detail.value);
    var data = {
      multiArray_top: this.data.multiArray_top,
      multiIndex_top: this.data.multiIndex_top
    };
    data.multiIndex_top[e.detail.column] = e.detail.value;
    
    this.setData(data);
  },

  onTapNewMeal(){
    wx.navigateTo({
      url: '../choices/choices',
    })
  },

  onTapSpecificItem(e){
    var item = JSON.stringify(e.currentTarget.dataset.product)
    console.log(e)
    wx.navigateTo({
      url: '../change_stock/change_stock?item='+item,
    })
  },

  test_GET(){
    wx.cloud.callContainer({
      "config": {
        "env": "prod-2g058voqbea31ecb"
      },
      "path": "test_get_post/",
      "header": {
        "X-WX-SERVICE": "django-5198",
        "content-type": "application/json"
      },
      "method": "GET",
      data: {type:'vegewswswsws'},
      success(res){
        console.log(res.data)
      }
    })
  },

  test_POST(){
    wx.cloud.callContainer({
      "config": {
        "env": "prod-2g058voqbea31ecb"
      },
      "path": "test_get_post/",
      "header": {
        "X-WX-SERVICE": "django-5198",
        'content-type': 'application/x-www-form-urlencoded'
      },
      "method": "POST",
      data: {name:'John',age:18,hobby:'golf'},
      success(res){
        console.log(res)
      }
    })
  },

  onTapNewFood(){
    wx.navigateTo({
      url: '../add_new_food/add_new_food',
    })
  },

  stock_longpress(e){
    var item = e.currentTarget.dataset.product
    
  },
  set_alarm_days(){
    wx.showModal({
      title: '需要提醒放置了多少天（含）以上的食物？',
      showCancel : true,
      confirmText:"确定",
      cancelText:"取消",
      editable:true,
      placeholderText:"如：3，请输入阿拉伯数字",
      success:(res)=>{
        console.log(res)
        if(res.confirm){
          if(res.content&&!isNaN(Number(res.content))&&Number(res.content)>=1&&Number(res.content)%1==0){
            this.setData({
              day_limit:res.content,
          })
          this.get_food_stock()
          }
          else{
            wx.showModal({
              title: '错误',
              content:"请输入正整数！",
              showCancel : false,
              confirmText:"确定",
            })
          }
          
        }
      }
    })
  }
})
