from django.db import models
from fridge.models import *
from general.models import *


class Dish(models.Model):
    name = models.CharField(max_length=80)
    time = models.DecimalField(max_digits=6,decimal_places=1, default=0)


class DishFlavor(Flavor):
    dish = models.ForeignKey(Dish, on_delete=models.CASCADE, default='')


class Material(models.Model):
    amount = models.CharField(max_length=12)
    dish = models.ForeignKey(Dish, on_delete=models.CASCADE, default='')
    food_type = models.ForeignKey(FoodType,on_delete=models.CASCADE,default='')
    is_important = models.BooleanField(default=True)


class Step(models.Model):
    order = models.IntegerField()
    text = models.TextField(max_length=100)
    time = models.DecimalField(max_digits=6, decimal_places=1)
    dish = models.ForeignKey(Dish, on_delete=models.CASCADE, default='')
